// mutex_test.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <boost/thread.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>
namespace pt = boost::posix_time;
#include "error_handling.h"

boost::timed_mutex mutex;
boost::mutex out_guard;

void thread_func()
{
	while (!boost::this_thread::interruption_requested()) 
	{
		bool locked = false;
		{
			boost::timed_mutex::scoped_lock lock(mutex, pt::milliseconds(1));
			locked = lock.owns_lock();
			boost::this_thread::sleep(pt::milliseconds(1));
		}
		boost::mutex::scoped_lock lock(out_guard);
		std::cout << (locked? "1": "0");
	}
}

void dummy() {}

int main(int argc, char* argv[])
{
	setup_error_handling();
	boost::thread_group tg;
	for (size_t i = 0; i != 20; ++i)
		tg.create_thread(thread_func);
	boost::this_thread::sleep(pt::seconds(5));
	tg.interrupt_all();
	tg.join_all();
	std::cout << "\nfinished\n";
	return 0;
}

